package controller

import (
	"blazing/common/data/share"

	"blazing/common/socket/errorcode"

	"blazing/logic/service/common"
	"blazing/logic/service/user"

	"blazing/logic/service/maps"
	"blazing/logic/service/player"
	"blazing/logic/service/space"
	"blazing/modules/blazing/model"
	blservice "blazing/modules/blazing/service"
	"context"
	"time"

	"github.com/gogf/gf/v2/os/glog"
)

func IsToday(t time.Time) bool {
	// 获取当前时间
	now := time.Now()

	// 比较年、月、日是否相同
	return t.Year() == now.Year() &&
		t.Month() == now.Month() &&
		t.Day() == now.Day()
}

// 处理命令: 1001
func (h *Controller) Login(data *user.MAIN_LOGIN_IN, c *player.Conn) (result *user.LoginMSInfo, err errorcode.ErrorCode) { //这个时候player应该是空的

	if tt := data.CheakSession(); tt { //说明sid正确
		h.RPCClient.Kick(data.Head.UserID) //先踢人

		t := player.GetPlayer(c, data.Head.UserID)
		t.Service = blservice.NewUserService(data.Head.UserID)
		t.Info = t.Service.Person()
		t.Info.UserID = data.Head.UserID
		t.Onlinetime = uint32(time.Now().Unix()) //保存时间戳

		share.ShareManager.SetUserOnline(data.Head.UserID, h.Port) //设置用户登录服务器

		if !IsToday(t.Info.LastResetTime) { //判断是否是今天
			t.Info.LastResetTime = time.Now()
			//每天login时候检查重置时间，然后把电池，任务，挖矿重置
			//挖矿需要单独存，因为防止多开挖矿
			t.Info.TimeToday = 0 //重置电池
			defer func() {
				for i := 400; i < 500; i++ { //每日任务区段
					t.Info.TaskList[i] = 0 //重置每日任务

					t.Service.Task((uint32(i)), func(te *model.TaskEX) bool {
						te.Data = make([]uint32, 0)
						return true
					})

				}
				for i := 400; i < 50; i++ { //每日任务区段
					t.Info.DailyResArr[i] = 0 //重置每日任务

				}
			}()

		}

		t.CompleteLogin() //通知客户端登录成功

		glog.Debug(context.Background(), "登录成功,初始地图 人数:", space.GetSpace(t.Info.MapID).Len())

		result = user.NewOutInfo() //设置登录消息

		result.PlayerInfo = *t.Info

		tt := maps.NewOutInfo()
		//copier.Copy(t.Info, tt)
		t1 := player.NewTomeeHeader(2001, t.Info.UserID)
		defer space.GetSpace(t.Info.MapID).Set(t.Info.UserID, t).Range(func(playerID uint32, player common.PlayerI) bool {

			player.SendPack(t1.Pack(&tt))

			return true
		})

		return result, 0

	} else {
		err = errorcode.ErrorCodes.ErrLoginServerError

	}
	return
}
